/*
	Clase: input.class.js
	Esta clase se encarga de interceptar eventos de teclado y mouse
	Si se desean capturar eventos de mouse se debe pasar true al momento
	de inicializar la clase
	
*/

var Input = function( bolMouseCatch ){
	var globalkeys = {};
	var controls;
	var mousepos  = new Array();
	var keyStatus = new Array();
	
// ------------------------------------------------------------------ //	
	
	this.clearBuffer = function()
	{
		for(var i=0; i < globalkeys.controls.length; i++ )
		{
			globalkeys.setKeyState( globalkeys.controls[ i ], 0 );
		}
	}
	
// ------------------------------------------------------------------ //

	globalkeys.setKeyState = function( KeyID, status ){
		switch( KeyID ){
			case this.controls[ 6 ] :
				this.keyStatus.fire2 = status;
				break;
			case this.controls[ 4 ] :
				this.keyStatus.menu = status;
				break;
			case this.controls[ 5 ] :
				this.keyStatus.fire1 = status;
				break;
			case this.controls[ 3 ] :
				this.keyStatus.left = status;
				break;
			case this.controls[ 0 ] :
				this.keyStatus.up = status;
				break;
			case this.controls[ 1 ] :
				this.keyStatus.right = status;
				break;
			case this.controls[ 2 ] :
				this.keyStatus.down = status;
				break;
			case this.controls[ 7 ] :
				this.keyStatus.lclick = status;
				break;
			case this.controls[ 8 ] :
				this.keyStatus.rclick = status;
				break;
			case this.controls[ 9 ] :
				this.keyStatus.mclick = status;
				break;
		}
	}

// ------------------------------------------------------------------ //
	
	this.detectMouseMove = function( e ){
		var evt = e || window.event;
		this.mousepos.x = evt.clientX;
		this.mousepos.y = evt.clientY;	
	}

// ------------------------------------------------------------------ //
	
	this.getMouseKeyCode = function( evt ){
		var mouse_code = 0;
		if ( evt.which ) {
			switch( evt.which ){
				case 1 :
					mouse_code = 100;
					break;
				case 2 :
					mouse_code = 102;
					break;
				case 3 :
					mouse_code = 101;
					break;
			}
		} else if ( evt.button ) {
			switch( evt.button ){
				case 1 :
					mouse_code = 100;
					break;
				case 2 :
					mouse_code = 101;
					break;
				case 3 :
					mouse_code = 102;
					break;
			}
		}
		return mouse_code;
	}

// ------------------------------------------------------------------ //
	
	this.detectMouseDown = function ( e ) {
		var evt = e || window.event;
		this.setKeyState( this.getMouseKeyCode( evt ), 1 );
	}

// ------------------------------------------------------------------ //
	
	this.detectMouseUp = function( e ) {
		var evt = e || window.event;
		this.setKeyState( this.getMouseKeyCode( evt ), 0 );
	}

// ------------------------------------------------------------------ //
	
	this.detectKeyDown = function( e ) {
		var evt = e || window.event;
		KeyID = evt.keyCode;
		globalkeys.setKeyState( KeyID, 1 );
	}

// ------------------------------------------------------------------ //
	
	this.detectKeyUp = function(e) {
		var evt = e || window.event;
		KeyID = evt.keyCode;
		globalkeys.setKeyState( KeyID, 0 );
	}

// ------------------------------------------------------------------ //
	
	this.KeyStatus = function( strKey ){
		return globalkeys.keyStatus[ strKey ];
	}

// ------------------------------------------------------------------ //
	
	this.MousePos = function( strAxis ){
		return this.mousepos[ strAxis ];
	}

// ------------------------------------------------------------------ //
	
	this.MouseCatch = function( bolActivate ){
		if( bolActivate ){
			document[ 'onmousemove' ] = this.detectMouseMove;
			window[ 'onmousedown'   ] = this.detectMouseDown;
			window[ 'onmouseup'     ] = this.detectMouseUp;
		} else {
			document[ 'onmousemove' ] = null;
			window[ 'onmousedown'   ] = null;
			window[ 'onmouseup'     ] = null;
			globalkeys.setKeyState( 100, 0 );
			globalkeys.setKeyState( 101, 0 );
			globalkeys.setKeyState( 102, 0 );
			globalkeys.mousepos.x = 0;
			globalkeys.mousepos.y = 0;
		}
	}

// ------------------------------------------------------------------ //
	
	this._init = function( bolCatchMouse ){
		globalkeys.controls = [
					38,  // Up
					39,  // Right
					40,  // Down
					37,  // Left
					27,  // Escape: Menu
					32,  // Space: Fire1
					17,  // Control: Fire2
					100, // Left Click
					101, // Right Click
					102  // Middle Click
				];
		globalkeys.mousepos = {'x' :0, 'y' :0 };
		globalkeys.keyStatus = {
					'up'    : 0,
					'right' : 0,
					'down'  : 0,
					'left'  : 0,
					'menu'  : 0,
					'fire1' : 0,
					'fire2' : 0,
					'rclick': 0,
					'lclick': 0,
					'mclick': 0
				};	
		
		document[ 'onkeydown' ] = this.detectKeyDown;
		document[ 'onkeyup'   ] = this.detectKeyUp;
		
		this.MouseCatch( bolMouseCatch );
	}

// ------------------------------------------------------------------ //
	
	this._init( bolMouseCatch );
	
}
