/*
	Class: layer_tiles.class.js
	
*/ 


var Layer_Tiles = Layer;

Layer_Tiles.prototype =
{
	_type          : "tiles",
	_name          : "Tiles1",
	_levelMap      : null,
	_collitionMask : null,
	_intTilemap    : null,
		
/* ------------------------------------------------------------------ */	

	levelMap : function ( levelmap )
	{
		if( levelmap )
		{
			this._levelMap = levelmap;
		} else {
			return this._levelMap;
		}
	},
	
/* ------------------------------------------------------------------ */	

	initialize : function( data )
	{
		if( data.levelmap     ) this._levelMap = data.levelmap;
		this._initialize( data );
	},

/* ------------------------------------------------------------------ */	

	checkCollition : function( coords )
	{
		for( var i = 0; i < coords.length; i++ )
		{
			var tileX    = Math.floor( coords[ i ][ 0 ] / 48 );
			var tileY    = Math.floor( coords[ i ][ 1 ] / 48 );
			var tilePosX = Math.floor( ( coords[ i ][ 0 ] % 48 ) / 8 );
			var tilePosY = Math.floor( ( coords[ i ][ 1 ] % 48 ) / 8 );
			var tileId   = this._levelMap[ tileX ][ tileY ];
			tileId--;
			if( tileId >= 0 ) 
			{
				if( this._collitionMask[ tileId ][ tilePosY ][ tilePosX ] == 1) return true;
			}
		}
		return false;
	},

/* ------------------------------------------------------------------ */	
	
	getTileTop : function( intTileNum )
	{
		return Math.floor( ( intTileNum - 1 ) / this._intTilemap ) * 48;
	},

/* ------------------------------------------------------------------ */	
	
	getTileLeft : function( intTileNum )
	{
		return ( ( intTileNum - 1 ) % this._intTilemap ) * 48;
	},
	
/* ------------------------------------------------------------------ */	

	fillTiles : function()
	{
		this._layer.clearAll();
		var tiles_width  = ( this._size.width / 48 );
		var tiles_height = ( this._size.height / 48 );
		for( var y = 0; y < ( 0 + tiles_height ); y++ )
			for( var x = 0; x < ( 0 + tiles_width ); x++ )
				if( this._levelMap[ y ][ x ] > 0 )
				{
					this._layer.drawImageRect(
						this._tilemap.getCanvas(), 
						this.getTileLeft( this._levelMap[ y ][ x ] ), 
						this.getTileTop(  this._levelMap[ y ][ x ] ), 
						48, 48, ( 48 * x ), ( 48 * y )
					);
				}
	}
	
/* ------------------------------------------------------------------ */	
	
}
