/*
	Clase: surface.class.js
	Este objeto debería definir una superficie
	si se le pasa un canvas como parametro, usa ese canvas como superficie
	si se le pasa un id de un objeto canvas lo instancia como superficie
	si se le pasa un '0' como cadena y un ancho y alto crea un nuevo objeto canvas y lo usa como superficie
	ej:
	Para crear una superficie de un objeto 'canvas' existente en el DOM pasamos el id del canvas
	var s = new Surface( 'superficie' );
	
	Para crear una superficie partiendo de un canvas existente, pasamos el canvas como parametro
	var s = new Surface( objCanvas );
	
	Para crear una nueva superficie de 800x600
	var s = new Surface( '0', 800, 600 );
	
*/ 

var Surface = function( strSurface, strWidth, strHeight )
{
	var _canSurface;
	var ctxSurface;
	
	
////////////////////////////////////////////////////////////////////////
//           INICIALIZA EL CANVAS Y EL CONTEXTO                       //
////////////////////////////////////////////////////////////////////////	
	this._init = function( strSurface, strWidth, strHeight )
	{
		if(typeof strSurface == 'canvas' )
		{
			_canSurface = strSurface;
		} else {
			if( strSurface != '0')
			{
				_canSurface  = document.getElementById( strSurface );
				if( strWidth  ) _canSurface.width  = strWidth;
				if( strHeight ) _canSurface.height = strHeight;
			} else {
				_canSurface        = document.createElement( 'canvas' );
				_canSurface.width  = strWidth;
				_canSurface.height = strHeight;
			}
		}
		this.ctxSurface = _canSurface.getContext( "2d" );
	}
	
	
	this.clearAll = function()
	{
		this.ctxSurface.clearRect(0, 0, _canSurface.width, _canSurface.height );
	}
	
	this.clearRect = function( intX, intY, intWidth, intHeight )
	{
		this.ctxSurface.clearRect( intX, intY, intWidth, intHeight );
	}
	
// context.drawImage(img,sx,sy,swidth,sheight,x,y,width,height);	
	this.drawImageRect = function( canOrigin, intOrigLeft, intOrigTop, intOrigWidth, intOrigHeight, intX, intY )
	{
		this.ctxSurface.drawImage(  canOrigin, 
									intOrigLeft, 
									intOrigTop, 
									intOrigWidth, 
									intOrigHeight, 
									intX, 
									intY,
									intOrigWidth, 
									intOrigHeight );
	}
	
	this.drawImage = function( canOrigin, intX, intY )
	{
		this.ctxSurface.drawImage( canOrigin, intX, intY );
	}
	
	this.getCanvas = function()
	{
		return _canSurface;
	}

	this.Size = function( set )
	{
		if( set )
		{
			if( set.width  ) _canSurface.width  = set.width;
			if( set.height ) _canSurface.height = set.height;
		} else {
			return { width : _canSurface.width, height : _canSurface.height }
		}
	}
	
////////////////////////////////////////////////////////////////////////
//                     INICIALIZA LA CLASE                            //
////////////////////////////////////////////////////////////////////////
	if( ! strSurface && ! strWidth && ! strHeight ) 
	{
		console.log('new Suerface(): ERROR - Faltan parámetros de inicialización');
	} else { 
		this._init( strSurface, strWidth, strHeight );
	}
}
