var Toolbox = function()
{

//--------------------------------------------------------------------//	

	this.imageToSurface = function( imgImage )
	{
		if(typeof imgImage.width == 'number')
		{
			var s = new Surface('0', imgImage.width, imgImage.height );
			s.drawImage( imgImage, 0, 0 );
			return s;
		} else {
			return false;
		}
	};
	
//--------------------------------------------------------------------//	

	this.RunPrefixMethod = function( obj, method ) 
	{
		var prefixMethod = ["webkit", "moz", "ms", "o", ""];
		var p = 0, m, t;
		while (p < prefixMethod.length && !obj[m]) {
			m = method;
			if (prefixMethod[p] == "") {
				m = m.substr(0,1).toLowerCase() + m.substr(1);
			}
			m = prefixMethod[p] + m;
			t = typeof obj[m];
			if (t != "undefined") {
				prefixMethod = [prefixMethod[p]];
				if ( t == "function" ) obj[m]();
				document.getElementById('canvas').mozRequestFullScreen();
				return true;
			}
			p++;
		}
	}

//--------------------------------------------------------------------//	

	this.setFullScreen = function( idCanvas, status )
	{
		var e = document.getElementById( idCanvas );
		if( status == 0 )
		{
			this.RunPrefixMethod( document, "CancelFullScreen" );
		} else {
			var r = this.RunPrefixMethod( e, "RequestFullScreen" );
		}
	}

//--------------------------------------------------------------------//	

	this.FrameTimer = function() 
	{
		_lastTick     = (new Date()).getTime();
		_frameSpacing = 0;
		
		this.getSeconds = function() 
		{
			var seconds = _frameSpacing / 1000;
			if( isNaN( seconds ) ) 
			{
				return 0;
			}
			return seconds;
		};
	 
		this.tick = function() 
		{
			var currentTick    = ( new Date() ).getTime();
			_frameSpacing = currentTick - _lastTick;
			_lastTick     = currentTick;
		}

	};
 
 //--------------------------------------------------------------------//	
 
};
